#pragma once

#include <unordered_map>
#include <string>

namespace I18nData {
    static const std::unordered_map<std::string, std::string> i18nData_default = {
        { "local_file_already_latest", "The local file is the latest version. Do you want to update it?" },
        { "dmmUnlockSize", "Unlock Window Size" },
        { "dmmUnlockSizeHelp", "You can freely resize the window. Press F11 to toggle fullscreen." },

        { "app_name", "Gakumas Localify" },
        { "gakumas_localify", "Gakumas Localify" },
        { "enable_plugin", "Enable Plugin (Not Hot Reloadable)" },
        { "replace_font", "Replace Font" },
        { "lazy_init", "Fast Initialization (Lazy loading)" },
        { "enable_free_camera", "Enable Free Camera" },
        { "start_game", "Start Game / Hot Reload Config" },
        { "setFpsTitle", "Max FPS (0 is Use Original Settings)" },
        { "unlockAllLive", "Unlock All Live" },
        { "unlockAllLiveCostume", "Unlock All Live Costume" },
        { "liveUseCustomeDress", "Live Custom Character" },
        { "live_costume_head_id", "Live Custom Head ID (eg. costume_head_hski-cstm-0002)" },
        { "live_custome_dress_id", "Live Custom Dress ID (eg. hski-cstm-0002)" },
        { "useCustomeGraphicSettings", "Use Custom Graphics Settings" },
        { "renderscale", "RenderScale (0.5/0.59/0.67/0.77/1.0)" },
        { "text_hook_test_mode", "Text Hook Test Mode" },
        { "useMasterDBTrans", "Enable MasterDB Localization" },
        { "export_text", "Export Text" },
        { "force_export_resource", "Force Update Resource" },
        { "login_as_ios", "Login as iOS" },
        { "max_high", "Ultra" },
        { "very_high", "Very High" },
        { "hign", "High" },
        { "middle", "Mid" },
        { "low", "Low" },
        { "orientation_orig", "Original" },
        { "orientation_portrait", "Portrait" },
        { "orientation_landscape", "Landscape" },
        { "orientation_lock", "Orientation Lock" },
        { "enable_breast_param", "Enable Breast Param" },
        { "damping", "Damping" },
        { "stiffness", "Stiffness" },
        { "spring", "Spring" },
        { "pendulum", "Pendulum" },
        { "pendulumrange", "Pendulum Range" },
        { "average", "Average" },
        { "rootweight", "Root Weight" },
        { "uselimit_0_1", "Limit Range Multiplier (0 is Unlimited)" },
        { "usearmcorrection", "Use Arm Correction" },
        { "isdirty", "IsDirty" },
        { "usescale", "Use Breast Scale" },
        { "breast_scale", "Breast Scale" },
        { "uselimitmultiplier", "Use Limit Multiplier" },
        { "axisx_x", "axisX.x" },
        { "axisy_x", "axisY.x" },
        { "axisz_x", "axisZ.x" },
        { "axisx_y", "axisX.y" },
        { "axisy_y", "axisY.y" },
        { "axisz_y", "axisZ.y" },
        { "basic_settings", "Basic Settings" },
        { "graphic_settings", "Graphic Settings" },
        { "camera_settings", "Camera Settings" },
        { "test_mode_live", "Test Mode - LIVE" },
        { "debug_settings", "Debug Settings" },
        { "breast_param", "Breast Parameters" },
        { "about", "About" },
        { "home", "Home" },
        { "advanced_settings", "Advanced" },
        { "about_warn_title", "WARNING" },
        { "about_warn_p1", "This plugin is for learning and communication only." },
        { "about_warn_p2", "Using external plugin against the relevant TOS so proceed at your own risk." },
        { "about_about_title", "About This Plugin" },
        { "about_about_p1", "This plugin is completely free. If you paid for this plugin, please report the seller." },
        { "about_about_p2", "Plugin QQ group: 975854705" },
        { "project_contribution", "Project Contribution" },
        { "plugin_code", "Plugin Code" },
        { "contributors", "Contributors" },
        { "translation_repository", "Translation Repository" },
        { "resource_settings", "Resource Settings" },
        { "check_built_in_resource", "Check Built-in Assets Update" },
        { "delete_plugin_resource", "Delete Plugin Resource" },
        { "use_remote_zip_resource", "Use Remote ZIP Resource" },
        { "resource_url", "Resource URL" },
        { "download", "Download" },
        { "invalid_zip_file", "Invalid file" },
        { "invalid_zip_file_warn", "This file is not a valid ZIP translation resource pack." },
        { "cancel", "Cancel" },
        { "ok", "OK" },
        { "downloaded_resource_version", "Downloaded Version" },
        { "del_remote_after_update", "Delete Cache File After Update" },
        { "warning", "Warning" },
        { "install", "Install" },
        { "installing", "Installing" },
        { "check_resource_from_api", "Check Resource Update From API" },
        { "api_addr", "API Address（Github Latest Release API）" },
        { "check_update", "Check" },
        { "translation_resource_update", "Translation Resource Update" },
        { "game_patch", "Game Patch" },
        { "patch_mode", "Patch Mode" },
        { "patch_local", "Local" },
        { "patch_local_desc", "Patch an app without modules embedded.\\nXposed scope can be changed dynamically without re-patch.\\nLocal patched apps can only run on the local device." },
        { "patch_integrated", "Integrated" },
        { "patch_integrated_desc", "Patch an app with modules embedded.\\nThe patched app can run without the manager, but cannot be managed dynamically.\\nIntegrated patched apps can be used on devices that do not have LSPatch Manager installed." },
        { "shizuku_available", "Shizuku service available" },
        { "shizuku_unavailable", "Shizuku service not connected" },
        { "home_shizuku_warning", "Some functions unavailable" },
        { "patch_debuggable", "Debuggable" },
        { "reserve_patched", "Reserve Patched APK" },
        { "support_file_types", "Supported files:\\nSingle/Multiple Choice: apk\\nSingle Choice: apks, xapk, zip" },
        { "patch_uninstall_text", "Due to different signatures, you need to uninstall the original app before installing the patched one.\\nMake sure you have backed up personal data." },
        { "patch_uninstall_confirm", "Are you sure you want to uninstall?" },
        { "patch_finished", "Patch finished. Start installing?" },
        { "about_contributors_asset_file", "about_contributors_en.json" },
        { "default_assets_check_api", "https://api.github.com/repos/NatsumeLS/Gakumas-Translation-Data-EN/releases/latest" },
    };
}