#pragma once

#include <unordered_map>
#include <string>

namespace I18nData {
    static const std::unordered_map<std::string, std::string> i18nData_ja = {
        { "local_file_already_latest", "ローカルファイルはすでに最新バージョンです。それでも更新を続けますか？" },
        { "dmmUnlockSize", "ウィンドウサイズの制限を解除" },
        { "dmmUnlockSizeHelp", "ウィンドウサイズは自由に変更できます。F11キーで全画面表示を切り替えます。" },

        { "about", "情報" },
        { "about_about_p1", "このプラグインは完全に無料で提供されます。このプラグインで料金を支払ってしまった場合は、販売者に報告をしてください。" },
        { "about_about_p2", "プラグインの QQ グループ: 975854705" },
        { "about_about_title", "このプラグインについて" },
        { "about_contributors_asset_file", "about_contributors_en.json" },
        { "about_warn_p1", "このプラグインは学習とコミュニケーションのみを目的としています。" },
        { "about_warn_p2", "外部プラグインは関連する TOS に違反するため、自己責任でご使用ください。" },
        { "about_warn_title", "警告" },
        { "advanced_settings", "高度な設定" },
        { "api_addr", "APIアドレス (GitHub の最新リリース API)" },
        { "app_name", "Gakumas Localify" },
        { "average", "平均" },
        { "axisx_x", "X 軸.x" },
        { "axisx_y", "X 軸.y" },
        { "axisy_x", "Y 軸.x" },
        { "axisy_y", "Y 軸.y" },
        { "axisz_x", "Z 軸.x" },
        { "axisz_y", "Z 軸.y" },
        { "basic_settings", "基本設定" },
        { "breast_param", "胸のパラメーター" },
        { "breast_scale", "胸の大きさ" },
        { "camera_settings", "カメラ設定" },
        { "cancel", "キャンセル" },
        { "character_counter_content_description", "%1$d の %2$d に入力された文字" },
        { "character_counter_overflowed_content_description", "文字制限が %2$d 文字中、 %1$d 文字を超えています" },
        { "character_counter_pattern", "%1$d/%2$d" },
        { "check_built_in_resource", "内蔵アセットのアップデートを確認" },
        { "check_resource_from_api", "リソースアップデートを API から確認" },
        { "check_update", "確認" },
        { "clear_text_end_icon_content_description", "テキストを消去" },
        { "close_drawer", "ナビゲーションメニューを閉じる" },
        { "close_sheet", "シートを閉じる" },
        { "contributors", "貢献者" },
        { "damping", "ダンプ中" },
        { "debug_settings", "デバッグ設定" },
        { "default_assets_check_api", "https://api.github.com/repos/NatsumeLS/Gakumas-Translation-Data-EN/releases/latest" },
        { "default_error_message", "入力が無効です" },
        { "default_popup_window_title", "ポップアップウィンドウ" },
        { "del_remote_after_update", "キャッシュファイルをアップデート後に削除" },
        { "delete_plugin_resource", "プラグインリソースを削除" },
        { "download", "ダウンロード" },
        { "downloaded_resource_version", "ダウンロードされたバージョン" },
        { "dropdown_menu", "ドロップダウンメニュー" },
        { "enable_breast_param", "胸のパラメーターを有効化" },
        { "enable_free_camera", "フリーカメラを有効化" },
        { "enable_plugin", "プラグイン有効化 (ホットリロードなし)" },
        { "error_a11y_label", "エラー: 無効" },
        { "error_icon_content_description", "エラー" },
        { "export_text", "テキストをエクスポート" },
        { "exposed_dropdown_menu_content_description", "ドロップダウンメニューを表示" },
        { "force_export_resource", "リソースのアップデートを強制する" },
        { "login_as_ios", "iOSとしてログイン" },
        { "gakumas_localify", "Gakumas Localify" },
        { "game_patch", "ゲームパッチ" },
        { "graphic_settings", "グラフィック設定" },
        { "hign", "高" },
        { "home", "ホーム" },
        { "home_shizuku_warning", "一部の機能が使用できません" },
        { "icon_content_description", "ダイアログアイコン" },
        { "in_progress", "実行中" },
        { "indeterminate", "部分的にチェック済み" },
        { "install", "インストール" },
        { "installing", "インストール中" },
        { "invalid_zip_file", "無効なファイル" },
        { "invalid_zip_file_warn", "このファイルは有効な ZIP 翻訳リソースパックではありません。" },
        { "isdirty", "IsDirty" },
        { "item_view_role_description", "タブ" },
        { "lazy_init", "高速な初期化 (読み込みを遅延)" },
        { "liveUseCustomeDress", "ライブのキャラクターをカスタム" },
        { "live_costume_head_id", "ライブのカスタムヘッド ID (例: costume_head_hski-cstm-0002)" },
        { "live_custome_dress_id", "ライブ衣装のカスタム ID (例: hski-cstm-0002)" },
        { "low", "低" },
        { "max_high", "ウルトラ" },
        { "middle", "中" },
        { "off", "OFF" },
        { "ok", "OK" },
        { "on", "ON" },
        { "orientation_landscape", "横画面" },
        { "orientation_lock", "画面を固定" },
        { "orientation_orig", "オリジナル" },
        { "orientation_portrait", "縦画面" },
        { "password_toggle_content_description", "パスワードを表示" },
        { "patch_debuggable", "デバッグを可能にする" },
        { "patch_finished", "パッチが完了しました。インストールをしますか？" },
        { "patch_integrated", "統合" },
        { "patch_integrated_desc", "\"モジュールを埋め込んだ状態なアプリでパッチを当てます。\\nパッチを適用したアプリは LSPatch Manager なしで実行できますが、動的に管理はできません。\\n統合パッチが適用されたアプリは、LSPatch Manager がインストールされていないデバイスでも使用が可能です。\"" },
        { "patch_local", "ローカル" },
        { "patch_local_desc", "\"モジュールを埋め込まずにアプリにパッチを当てます。\\nXposed スコープは再パッチなしで動的に変更が可能です。\\nローカルでのパッチを当てたアプリは、ローカルのデバイスでのみ実行可能です。\"" },
        { "patch_mode", "パッチモード" },
        { "patch_uninstall_confirm", "アンインストールをしてもよろしいですか？" },
        { "patch_uninstall_text", "\"署名が異なるため、パッチをインストールする前に元となるアプリをアンインストールする必要があります。\\n個人データのバックアップを設定済みであることを確認してください。\"" },
        { "pendulum", "揺れ" },
        { "pendulumrange", "揺れの範囲" },
        { "plugin_code", "プラグインのコード" },
        { "project_contribution", "プロジェクトの貢献者" },
        { "range_end", "範囲の終了" },
        { "range_start", "範囲の開始" },
        { "renderscale", "RenderScale (0.5/0.59/0.67/0.77/1.0)" },
        { "replace_font", "フォントを置換する" },
        { "reserve_patched", "パッチ済みの APK を予約する" },
        { "resource_settings", "リソース設定" },
        { "resource_url", "リソース URL" },
        { "rootweight", "ルートウェイト" },
        { "selected", "選択済み" },
        { "setFpsTitle", "最大 FPS (0 はオリジナルの設定を使用します)" },
        { "shizuku_available", "Shizuku サービスが有効です" },
        { "shizuku_unavailable", "Shizuku サービスが接続されていません" },
        { "spring", "跳ね" },
        { "start_game", "ゲーム開始 / ホットリロードの設定" },
        { "stiffness", "剛性" },
        { "support_file_types", "\"対応ファイル:\\n単一または複数選択: apk\\n単一選択: apks、xapk、zip\"" },
        { "switch_role", "切り替え" },
        { "tab", "タブ" },
        { "template_percent", "%1$d パーセント。" },
        { "test_mode_live", "テストモード - ライブ" },
        { "text_hook_test_mode", "テキストフックテストモード" },
        { "useMasterDBTrans", "MasterDB をローカライズする" },
        { "translation_repository", "翻訳のリポジトリ" },
        { "translation_resource_update", "翻訳リソースをアップデート" },
        { "unlockAllLive", "すべてのライブを開放" },
        { "unlockAllLiveCostume", "すべてのライブ衣装を開放" },
        { "useCustomeGraphicSettings", "カスタムグラフィック設定を使用する" },
        { "use_remote_zip_resource", "リモート ZIP リソースを使用する" },
        { "usearmcorrection", "Arm コレクションを使用する" },
        { "uselimit_0_1", "リミットレンジの倍率 (0 は無制限)" },
        { "uselimitmultiplier", "乗数制限を使用する" },
        { "usescale", "胸の大きさを使用する" },
        { "very_high", "最高" },
        { "warning", "警告" },
    };
}