#pragma once

#include <unordered_map>
#include <string>

namespace I18nData {
    static const std::unordered_map<std::string, std::string> i18nData_zh_rCN = {
        { "local_file_already_latest", "本地文件已经是最新版本，是否继续更新？" },
        { "dmmUnlockSize", "解锁窗口大小" },
        { "dmmUnlockSizeHelp", "可随意拖动窗口大小。使用F11切换全屏。" },

        { "app_name", "Gakumas Localify" },
        { "gakumas_localify", "Gakumas Localify" },
        { "enable_plugin", "启用插件 (不可热重载)" },
        { "replace_font", "替换字体" },
        { "lazy_init", "快速初始化（懒加载配置）" },
        { "enable_free_camera", "启用自由视角（可热重载; 需使用实体键盘）" },
        { "start_game", "以上述配置启动游戏/重载配置" },
        { "setFpsTitle", "最大 FPS (0 为保持游戏原设置)" },
        { "unlockAllLive", "解锁所有 Live" },
        { "unlockAllLiveCostume", "解锁所有 Live 服装" },
        { "liveUseCustomeDress", "Live 使用自定义角色" },
        { "live_costume_head_id", "Live 自定义头部 ID (例: costume_head_hski-cstm-0002)" },
        { "live_custome_dress_id", "Live 自定义服装 ID (例: hski-cstm-0002)" },
        { "useCustomeGraphicSettings", "使用自定义画质设置" },
        { "renderscale", "RenderScale (0.5/0.59/0.67/0.77/1.0)" },
        { "text_hook_test_mode", "文本 hook 测试模式" },
        { "useMasterDBTrans", "使用 MasterDB 本地化" },
        { "export_text", "导出文本" },
        { "force_export_resource", "启动后强制导出资源" },
        { "login_as_ios", "以 iOS 登陆" },
        { "max_high", "极高" },
        { "very_high", "超高" },
        { "hign", "高" },
        { "middle", "中" },
        { "low", "低" },
        { "orientation_orig", "原版" },
        { "orientation_portrait", "竖屏" },
        { "orientation_landscape", "横屏" },
        { "orientation_lock", "方向锁定" },
        { "enable_breast_param", "启用胸部参数" },
        { "damping", "阻尼 (Damping)" },
        { "stiffness", "刚度 (Stiffness)" },
        { "spring", "弹簧系数 (Spring)" },
        { "pendulum", "钟摆系数 (Pendulum)" },
        { "pendulumrange", "钟摆范围 (PendulumRange)" },
        { "average", "Average" },
        { "rootweight", "RootWeight" },
        { "uselimit_0_1", "范围限制倍率 (0 为不限制, 1 为原版)" },
        { "usearmcorrection", "使用手臂矫正" },
        { "isdirty", "IsDirty" },
        { "usescale", "应用缩放" },
        { "breast_scale", "胸部缩放倍率" },
        { "uselimitmultiplier", "启用范围限制倍率" },
        { "axisx_x", "axisX.x" },
        { "axisy_x", "axisY.x" },
        { "axisz_x", "axisZ.x" },
        { "axisx_y", "axisX.y" },
        { "axisy_y", "axisY.y" },
        { "axisz_y", "axisZ.y" },
        { "basic_settings", "基础设置" },
        { "graphic_settings", "画面设置" },
        { "camera_settings", "摄像机设置" },
        { "test_mode_live", "测试模式 - LIVE" },
        { "debug_settings", "调试设置" },
        { "breast_param", "胸部参数" },
        { "about", "关于" },
        { "home", "主页" },
        { "advanced_settings", "高级设置" },
        { "about_warn_title", "使用前警告" },
        { "about_warn_p1", "本插件仅供学习和交流使用。" },
        { "about_warn_p2", "使用外部插件属于违反游戏条款的行为。若使用插件后账号被封禁，造成的后果由用户自行承担。" },
        { "about_about_title", "关于本插件" },
        { "about_about_p1", "本插件完全免费。若您付费购买了本插件，请举报店家。" },
        { "about_about_p2", "插件交流群: 975854705" },
        { "project_contribution", "项目贡献" },
        { "plugin_code", "插件本体" },
        { "contributors", "贡献者列表" },
        { "translation_repository", "译文仓库" },
        { "resource_settings", "资源设置" },
        { "check_built_in_resource", "检查内置数据更新" },
        { "delete_plugin_resource", "清除游戏目录内的插件资源" },
        { "use_remote_zip_resource", "使用远程 ZIP 数据" },
        { "resource_url", "资源地址" },
        { "download", "下载" },
        { "invalid_zip_file", "文件解析失败" },
        { "invalid_zip_file_warn", "此文件不是一个有效的 ZIP 翻译资源包" },
        { "cancel", "取消" },
        { "ok", "确定" },
        { "downloaded_resource_version", "已下载资源版本" },
        { "del_remote_after_update", "替换文件后删除下载缓存" },
        { "warning", "注意" },
        { "install", "安装" },
        { "installing", "安装中" },
        { "check_resource_from_api", "从服务器检查热更新资源" },
        { "api_addr", "API 地址（Github Latest Release API）" },
        { "check_update", "检查更新" },
        { "translation_resource_update", "翻译资源更新" },
        { "game_patch", "游戏修补" },
        { "patch_mode", "修补模式" },
        { "patch_local", "本地模式" },
        { "patch_local_desc", "为未嵌入模块的应用程序打补丁。\\nXposed 范围可动态更改，无需重新打补丁。\\n打了本地补丁的应用程序只能在本地设备上运行。" },
        { "patch_integrated", "集成模式" },
        { "patch_integrated_desc", "修补 App 并内置模块。\\n经修补的应用可以在没有管理器的情况下运行，但不能动态管理配置。\\n以集成模式修补的应用可在未安装 LSPatch 管理器的设备上运行。" },
        { "shizuku_available", "Shizuku 服务可用" },
        { "shizuku_unavailable", "Shizuku 服务未连接" },
        { "home_shizuku_warning", "部分功能不可用" },
        { "patch_debuggable", "可调试" },
        { "reserve_patched", "安装时保留修补包" },
        { "support_file_types", "支持文件类型：\\n单/多选 apk\\n单选 apks, xapk, zip" },
        { "patch_uninstall_text", "由于签名不同，安装修补的应用前需要先卸载原应用。\\n确保您已备份好个人数据。" },
        { "patch_uninstall_confirm", "您确定要卸载吗" },
        { "patch_finished", "修补完成，是否开始安装？" },
        { "about_contributors_asset_file", "about_contributors_zh_cn.json" },
        { "default_assets_check_api", "https://uma.chinosk6.cn/api/gkms_trans_data" },
    };
}